import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS AppSync.
 *
 * @stability stable
 */
export interface AppsyncDatasourceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#api_id AppsyncDatasource#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#description AppsyncDatasource#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#name AppsyncDatasource#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#service_role_arn AppsyncDatasource#service_role_arn}.
     *
     * @stability stable
     */
    readonly serviceRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#type AppsyncDatasource#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * dynamodb_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#dynamodb_config AppsyncDatasource#dynamodb_config}
     *
     * @stability stable
     */
    readonly dynamodbConfig?: AppsyncDatasourceDynamodbConfig;
    /**
     * elasticsearch_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#elasticsearch_config AppsyncDatasource#elasticsearch_config}
     *
     * @stability stable
     */
    readonly elasticsearchConfig?: AppsyncDatasourceElasticsearchConfig;
    /**
     * http_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#http_config AppsyncDatasource#http_config}
     *
     * @stability stable
     */
    readonly httpConfig?: AppsyncDatasourceHttpConfig;
    /**
     * lambda_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#lambda_config AppsyncDatasource#lambda_config}
     *
     * @stability stable
     */
    readonly lambdaConfig?: AppsyncDatasourceLambdaConfig;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceDynamodbConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#region AppsyncDatasource#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#table_name AppsyncDatasource#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#use_caller_credentials AppsyncDatasource#use_caller_credentials}.
     *
     * @stability stable
     */
    readonly useCallerCredentials?: boolean | cdktf.IResolvable;
}
export declare function appsyncDatasourceDynamodbConfigToTerraform(struct?: AppsyncDatasourceDynamodbConfigOutputReference | AppsyncDatasourceDynamodbConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceDynamodbConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceDynamodbConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceDynamodbConfig | undefined);
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _tableName?;
    /**
     * @stability stable
     */
    get tableName(): string;
    /**
     * @stability stable
     */
    set tableName(value: string);
    /**
     * @stability stable
     */
    get tableNameInput(): string | undefined;
    private _useCallerCredentials?;
    /**
     * @stability stable
     */
    get useCallerCredentials(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useCallerCredentials(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseCallerCredentials(): void;
    /**
     * @stability stable
     */
    get useCallerCredentialsInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceElasticsearchConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#endpoint AppsyncDatasource#endpoint}.
     *
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#region AppsyncDatasource#region}.
     *
     * @stability stable
     */
    readonly region?: string;
}
export declare function appsyncDatasourceElasticsearchConfigToTerraform(struct?: AppsyncDatasourceElasticsearchConfigOutputReference | AppsyncDatasourceElasticsearchConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceElasticsearchConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceElasticsearchConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceElasticsearchConfig | undefined);
    private _endpoint?;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    set endpoint(value: string);
    /**
     * @stability stable
     */
    get endpointInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceHttpConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#endpoint AppsyncDatasource#endpoint}.
     *
     * @stability stable
     */
    readonly endpoint: string;
}
export declare function appsyncDatasourceHttpConfigToTerraform(struct?: AppsyncDatasourceHttpConfigOutputReference | AppsyncDatasourceHttpConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceHttpConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceHttpConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceHttpConfig | undefined);
    private _endpoint?;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    set endpoint(value: string);
    /**
     * @stability stable
     */
    get endpointInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceLambdaConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#function_arn AppsyncDatasource#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
}
export declare function appsyncDatasourceLambdaConfigToTerraform(struct?: AppsyncDatasourceLambdaConfigOutputReference | AppsyncDatasourceLambdaConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceLambdaConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceLambdaConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceLambdaConfig | undefined);
    private _functionArn?;
    /**
     * @stability stable
     */
    get functionArn(): string;
    /**
     * @stability stable
     */
    set functionArn(value: string);
    /**
     * @stability stable
     */
    get functionArnInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource aws_appsync_datasource}.
 *
 * @stability stable
 */
export declare class AppsyncDatasource extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource aws_appsync_datasource} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppsyncDatasourceConfig);
    private _apiId?;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _serviceRoleArn?;
    /**
     * @stability stable
     */
    get serviceRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceRoleArn(value: string);
    /**
     * @stability stable
     */
    resetServiceRoleArn(): void;
    /**
     * @stability stable
     */
    get serviceRoleArnInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _dynamodbConfig;
    /**
     * @stability stable
     */
    get dynamodbConfig(): AppsyncDatasourceDynamodbConfigOutputReference;
    /**
     * @stability stable
     */
    putDynamodbConfig(value: AppsyncDatasourceDynamodbConfig): void;
    /**
     * @stability stable
     */
    resetDynamodbConfig(): void;
    /**
     * @stability stable
     */
    get dynamodbConfigInput(): AppsyncDatasourceDynamodbConfig | undefined;
    private _elasticsearchConfig;
    /**
     * @stability stable
     */
    get elasticsearchConfig(): AppsyncDatasourceElasticsearchConfigOutputReference;
    /**
     * @stability stable
     */
    putElasticsearchConfig(value: AppsyncDatasourceElasticsearchConfig): void;
    /**
     * @stability stable
     */
    resetElasticsearchConfig(): void;
    /**
     * @stability stable
     */
    get elasticsearchConfigInput(): AppsyncDatasourceElasticsearchConfig | undefined;
    private _httpConfig;
    /**
     * @stability stable
     */
    get httpConfig(): AppsyncDatasourceHttpConfigOutputReference;
    /**
     * @stability stable
     */
    putHttpConfig(value: AppsyncDatasourceHttpConfig): void;
    /**
     * @stability stable
     */
    resetHttpConfig(): void;
    /**
     * @stability stable
     */
    get httpConfigInput(): AppsyncDatasourceHttpConfig | undefined;
    private _lambdaConfig;
    /**
     * @stability stable
     */
    get lambdaConfig(): AppsyncDatasourceLambdaConfigOutputReference;
    /**
     * @stability stable
     */
    putLambdaConfig(value: AppsyncDatasourceLambdaConfig): void;
    /**
     * @stability stable
     */
    resetLambdaConfig(): void;
    /**
     * @stability stable
     */
    get lambdaConfigInput(): AppsyncDatasourceLambdaConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
